#include<avr/io.h>
#include <util/delay.h>

#include <stdlib.h> 
#include <stdio.h> 
#include <string.h>

#define uint unsigned int
#define uchar unsigned char

#include "Nokia5110/Nokia5110.h"


char* questions[13] = {
	"Who created the C programming language?",
	"Linus Torvalds developed which operating system?", 
	"Which one is a volatile memory?",
	"What is the standard port used for ssh protocol?",
	"What is the number of bits used by the IPv6 address?",
	"What is the number of layers in the OSI model?",
	"Which protocol is used to receive emails?", 
	"Which off the following is a sorting algorithm?",
	"The acronym LIFO usually stands for ?",
	"Which one is an example of connectionless protocol?",
	"How it's called the first process in Unix?",
	"Which data structure uses key-value pairs?",
	"Which of the following is a functional language?"
};


char* answers[13][3] = {
	{ "a.Ken Thompson", "b.Dennis Ritchie", "c.Robin Milner" }, 
	{ "a.Windows", "b.Unix", "c.Linux"},
	{ "a.Hard Disk", "b.RAM", "c.ROM"},
	{ "a.21", "b.80", "c.22"} ,
	{ "a.32", "b.128", "c.256"},
	{ "a.4", "b.7", "c.9"},
	{ "a.SMTP", "b.POP3", "c.FTP"},
	{ "a.Cocktail sort", "b.Beef sort", "c.Spaghetti sort"},
	{ "a.Lost in Foreign Office", "b.Leave it For Others","c.Last In, First out"},
	{ "a.TCP", "b.Frame Relay", "c.UDP"},
	{ "a.zombie", "b.bo$$", "c.init"} ,
	{ "a.Tree", "b.HashMap", "c.Trie" } ,
	{ "a.Haskell", "b.Pascal" , "c.C++"}
};

#define MAX_SCORE 50

char corr_answers[13] = { 6, 5, 6, 5, 6, 6, 6, 7, 5, 5, 5, 6, 7};


int main(void) 
{
	DDRA=0x0F;
	PORTA=0xF0;
	srand(60);
	uint i;
	uint j, copy;
	char answered;
	char score;
	char text[70];
	LCD_init();       //LCD initialization
	j = rand()%13;
	copy = j;
	while (1) {
		LCD_clear();      //clear the LCD
		_delay_ms(100);
		LCD_write_string(0, 0, "**************");
		LCD_write_string(0, 1, "    Quiz CS   ");
		LCD_write_string(0, 3, "Press Start(*)");
		LCD_write_string(0, 5, "**************");

		// coloana a 1-a
		PORTA = 0b11110111;
		while(bit_is_set(PINA, 4)){}
		LCD_clear();
		score = 0;

		i = 0;
		
		while(1)	
		{
			memset(&text, 0, 70);
			sprintf(text,"%d.%s",i+1, questions[j]);
			LCD_write_string(0, 0, text);
			_delay_ms(4000);
			LCD_init();
			LCD_write_string(0, 0, answers[j][0]);
			LCD_write_string(0, 2, answers[j][1]);
			LCD_write_string(0, 4, answers[j][2]);

			answered = 0;

			while (1) {

				// coloana a 4-a
				PORTA = 0b11111110;
				// litera A 
				if (!bit_is_set(PINA, 7)) {
					answered = 7;
					PINA |= (1<<7);
				}

				// litera B 
				if (!bit_is_set(PINA, 6)) {
					answered = 6;
					PINA |= (1<<6);
				}


				// litera C 
				if (!bit_is_set(PINA, 5)) {
					answered = 5;
					PINA |= (1<<5);
				}

				if (answered != 0)
					break;
			}


			LCD_clear();
			if (answered == corr_answers[j]){
				LCD_write_string(0, 2, "CORRECT Answer!!!");
				score += 10;
			}else{
				LCD_write_string(0, 2, "Wrong Answer :(");
			}
		
			_delay_ms(2000);

			LCD_init();

			sprintf( text, "Your score %d", score );
			LCD_write_string(0,1,text);

			_delay_ms(2000);
			i++;
			j+=2;
			j = j%13;
			if( i > 4)
				break;

		}

		LCD_init();
		LCD_write_string(0, 0, "**************");
		if ( score == MAX_SCORE ) {
			LCD_write_string(0, 1, "Congrats! You've got all the answers right :)" );
		} else {
			LCD_write_string(0, 1, "Take it till you'll make it to the max :)");
		}
		LCD_write_string(0, 5, "**************");
		_delay_ms(4000);
		j = (copy + 1 )%13;
		copy = j;

	}
	return 0;
}



